#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1900seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 1900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1900seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven19004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven19004xi = {
                1:'-1042x-1434y682z',
                2:'-1047x-1177y1060z',
                3:'-1055x-1579y23z',
                4:'-1100x-1113y1076z',
                5:'-1111x-1372y699z',
                6:'-1136x-1522y42z',
                7:'-1149x-1047y1092z',
                8:'-1177x-1307y717z',
                9:'-1194x-978y1107z',
                10:'-1214x-1460y61z',
                11:'-1234x-908y1122z',
                12:'-1238x-1238y734z',
                13:'-126x-949y1640z',
                14:'-1271x-836y1138z',
                15:'-1288x-1394y80z',
                16:'-1296x-1167y752z',
                17:'-1303x-762y1153z',
                18:'-1330x-687y1168z',
                19:'-1349x-1093y769z',
                20:'-1354x-612y1183z',
                21:'-1358x-1324y99z',
                22:'-1373x-536y1198z',
                23:'-1388x-460y1212z',
                24:'-1398x-1016y787z',
                25:'-1398x-383y1227z',
                26:'-1404x-307y1241z',
                27:'-1425x-1250y118z',
                28:'-1443x-937y804z',
                29:'-1483x-856y821z',
                30:'-1488x-1173y137z',
                31:'-1519x-773y838z',
                32:'-1546x-1093y156z',
                33:'-1549x-689y855z',
                34:'-1575x-604y872z',
                35:'-1596x-518y889z',
                36:'-1599x-1009y175z',
                37:'-1613x-432y906z',
                38:'-1624x-345y922z',
                39:'-1631x-258y939z',
                40:'-1633x-171y955z',
                41:'-1648x-923y194z',
                42:'-167x-1683y864z',
                43:'-1693x-835y213z',
                44:'-172x-925y1650z',
                45:'-1732x-744y231z',
                46:'-1766x-652y250z',
                47:'-1796x-557y269z',
                48:'-17x-18y1899z',
                49:'-1820x-462y288z',
                50:'-18x-271y1880z',
                51:'-191x-1822y501z',
                52:'-217x-899y1659z',
                53:'-253x-1664y881z',
                54:'-259x-870y1668z',
                55:'-27x-990y1621z',
                56:'-285x-1804y519z',
                57:'-28x-34y1899z',
                58:'-298x-840y1677z',
                59:'-30x-251y1883z',
                60:'-335x-807y1686z',
                61:'-338x-1639y898z',
                62:'-370x-773y1695z',
                63:'-378x-1782y538z',
                64:'-38x-51y1898z',
                65:'-402x-738y1703z',
                66:'-40x-230y1885z',
                67:'-421x-1611y914z',
                68:'-431x-701y1712z',
                69:'-457x-664y1720z',
                70:'-46x-68y1898z',
                71:'-470x-1754y556z',
                72:'-47x-209y1887z',
                73:'-481x-625y1728z',
                74:'-4x-290y1877z',
                75:'-4x-4y1899z',
                76:'-502x-1577y931z',
                77:'-502x-586y1736z',
                78:'-520x-546y1743z',
                79:'-52x-87y1897z',
                80:'-531x-97y1821z',
                81:'-535x-506y1751z',
                82:'-53x-188y1889z',
                83:'-543x-129y1816z',
                84:'-547x-466y1758z',
                85:'-553x-163y1810z',
                86:'-557x-426y1765z',
                87:'-559x-1722y574z',
                88:'-560x-197y1804z',
                89:'-564x-386y1772z',
                90:'-566x-233y1798z',
                91:'-568x-347y1779z',
                92:'-569x-270y1792z',
                93:'-56x-106y1896z',
                94:'-570x-308y1785z',
                95:'-57x-167y1891z',
                96:'-581x-1540y947z',
                97:'-58x-126y1894z',
                98:'-59x-147y1893z',
                99:'-646x-1685y592z',
                100:'-657x-1499y964z',
                101:'-726x-612y1645z',
                102:'-730x-1454y980z',
                103:'-731x-1643y610z',
                104:'-742x-695y1721z',
                105:'-744x-563y1654z',
                106:'-758x-514y1664z',
                107:'-770x-465y1673z',
                108:'-778x-416y1682z',
                109:'-77x-971y1631z',
                110:'-784x-368y1690z',
                111:'-786x-320y1699z',
                112:'-79x-1698y847z',
                113:'-800x-1405y996z',
                114:'-814x-1597y628z ',
                115:'-867x-1353y1013z',
                116:'-893x-1547y646z',
                117:'-931x-1297y1029z',
                118:'-969x-1492y664z',
                119:'-96x-1834y483z',
                120:'-971x-1633y4z',
                121:'-991x-1239y1044z',
                122:'0x-1842y464z'}         
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1900seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1900seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1900SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE1900SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1900SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1900SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1900SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven19004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1900SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1900SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1900SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven19004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven19004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1900SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1900SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1900SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1900seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       